select ip.object_instance_id object_instance_id,
		nm1.id, c.name, 
		na1.action_code, 
		nm1.is_default,
        nm1.parent_menu_id,
		nm.menu_item_level menu_item_level,
		nm1.position position,
		nm1.image_name,
		nm1.is_required,
        nm1.principal_type principal_type, 
		nm1.principal_id,
        1 has_permission, na1.policy_id,
		'noPolicy' policy_code, NVL(nm1.is_hidden, 0) is_hidden
from   
		cmn_menu_items nm1, cmn_actions na1, cmn_menu_items nm,
		cmn_instance_pages ip, cmn_actions na, cmn_captions_nls c
		
where  na.action_code = ?
	and    ip.object_instance_id = ?
	and    nm.container_type_code = 'PANE'
	and    nm.item_type_code = 'PANE'
	and		nm1.container_type_code = 'PANE'
	and    nm1.item_type_code = 'PANE'
	and    nm.container_id = nm1.container_id
	and    ip.page_frame_id = nm1.container_id
	and    nm.action_id = na.id
	and    nm1.action_id = na1.id
	and    c.pk_id = nm1.id
	and    c.table_name = 'CMN_MENU_ITEMS'
	and    c.language_code = ?
	and    nm1.principal_type = 'USER'
	and    nm1.principal_id = ?
	and    (nm1.is_hidden is null or nm1.is_hidden=0) 

union
        
	
select ip.object_instance_id object_instance_id,
	nm1.id, c.name,
	na1.action_code,
	nm1.is_default,
	nm1.parent_menu_id, 
	nm.menu_item_level menu_item_level,
	nm1.position position, 
	nm1.image_name,
	nm1.is_required,
	nm1.principal_type principal_type, 
	nm1.principal_id,
--                1 CMN_SEC_CHECK_RIGHT_FCT ( ?, 'CMN', 'PAGE', 'PAGE', 'VIEW', na1.page_id) has_permission,
	1 has_permission,
	na1.policy_id, NVL(sp.policy_code, 'noPolicy'),
	NVL(nm1.is_hidden, 0) is_hidden

from   cmn_instance_pages ip, 
			cmn_menu_items nm1,   		
		 (
		   select id from cmn_menu_items
		   minus
		   select NVL(nm3.parent_menu_id,-1)
			from   cmn_menu_items nm3, cmn_actions na3, cmn_menu_items nm2, cmn_actions na2
		   where  na2.action_code = ?
		   and    nm2.item_type_code = 'PANE'
		   and    nm2.container_id = nm3.container_id
		   and    nm2.action_id = na2.id
		   and    nm3.action_id = na3.id
			and    nm3.principal_type = 'USER'
		   and    nm3.principal_id = ?
		 )nmm,  
		 cmn_actions na1, 
		 cmn_sec_policies sp,  
		 cmn_actions na, 
		 cmn_menu_items nm,
		 cmn_captions_nls c
 where  na.action_code = ? 
		 and    na1.policy_id = sp.id (+)  and    ip.object_instance_id = ?
         and    nm.item_type_code = 'PANE'
         and    nm.container_type_code = 'PANE'
         and    nm.container_id = nm1.container_id
         and    nm1.container_type_code = 'PANE'
         and    nm1.item_type_code = 'PANE'
         and    ip.page_frame_id = nm1.container_id
         and    nm.action_id = na.id
         and    nm1.action_id = na1.id
         and    c.pk_id = nm1.id
         and    c.table_name = 'CMN_MENU_ITEMS'
         and    c.language_code = ?
         and    nm1.principal_type = 'SYSTEM'
         and    nm1.principal_id = 0
         and    (nm1.is_hidden is null or nm1.is_hidden=0)
         and    nm1.id = nmm.id  
		 
		 order by object_instance_id,
		 principal_type,
		 menu_item_level,
		 position 